unit TernarySeries;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.ExtCtrls,
  VCLTee.TeEngine, VCLTee.TeeSurfa, VCLTee.TeeTernary, Vcl.StdCtrls,
  VCLTee.TeeProcs, VCLTee.Chart, VCLTee.TeeURL, VCLTee.TeeSeriesTextEd, Data.DB,
  DBTables, Data.Win.ADODB, VCLTee.Series, VCLTee.DBChart;

type
  TTernarySeriesForm = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    SeriesTextSource1: TSeriesTextSource;
    Chart1: TDBChart;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart1BeforeDrawAxes(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    SeriesListT: TStringList;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TernarySeriesForm: TTernarySeriesForm;
  Series1: TTernarySeries;
  kbmMemTable1: TTable;

implementation

{$R *.dfm}

Uses EditChar, TeeConst;

procedure TTernarySeriesForm.Button1Click(Sender: TObject);
begin
  EditSeries(Self,Series1);
end;

procedure TTernarySeriesForm.Button2Click(Sender: TObject);
var wIndex: Integer;
begin
  wIndex:=0;
  while (wIndex<SeriesTextSource1.Fields.Count) and (SeriesTextSource1.Fields[wIndex].FieldName <> 'Weighting') do
    Inc(wIndex);

  if wIndex<SeriesTextSource1.Fields.Count then
  begin
    if (SeriesTextSource1.Fields[wIndex].FieldIndex = 7) then
      SeriesTextSource1.Fields[wIndex].FieldIndex:=6
    else
      SeriesTextSource1.Fields[wIndex].FieldIndex:=7;
  end;

  SeriesTextSource1.Active:=True;
  Series1.CheckDataSource;
end;

procedure TTernarySeriesForm.Chart1BeforeDrawAxes(Sender: TObject);
begin
//  Chart1.Legend.Title.Visible := Series1.ColorEachPoint;
  Chart1.Legend.Title.Visible := True;
end;

procedure TTernarySeriesForm.FormCreate(Sender: TObject);
var
  z: boolean;
  Lkbm: TTable;
  af: TFieldDefs;
  i, t: integer;
  LADO: TADOQuery;
  aDataset1, aDataset2, aDataset3: TDataset;

begin
  inherited;

  Series1 := TTernarySeries.Create(Owner);
  Series1.ParentChart := Chart1;

  FormatSettings.DecimalSeparator:='.';

  Series1.DataSource := SeriesTextSource1;

  with SeriesTextSource1 do
  begin
    HeaderLines:=1;
    FileName := 'Na-Mg-K.csv';
    FieldSeparator:=',';
    Fields.Clear;

    AddField('X',3);
    AddField('Y',4);
    AddField('Z',5);
    AddField('Radius',6);
    AddField('Weighting',7);
    AddField('Text',8);
    Load;
  end;

  Series1.UseColorRange:=true;
  Series1.VertexTitles[0][0] := 'Na/1000' ;
  Series1.VertexTitles[1][0] := 'Sqrt(Mg)' ;
  Series1.VertexTitles[2][0] := 'K/100' ;

  Series1.Pointer.Style:=psDonut;
  Series1.Pointer.Transparency:=50;

  Chart1.Legend.TextStyle := ltsPlain;
  Chart1.Legend.Title.Text.Add('Sample Site  Sample Date');
  Chart1.Legend.Title.TextAlignment := taLeftJustify;
  Chart1.Legend.Width :=30;
  Chart1.Legend.Title.Visible:=true;
end;

end.
